import { Observable } from 'rxjs/Observable';
import { Connection, ConnectionBackend, ReadyState, Request, Response, ResponseOptions } from '@angular/http';
import { HTTP } from './cordova-http-plugin';
export interface HTTPError {
    error: string;
    status?: number;
    headers?: {
        [name: string]: string;
    };
}
export declare class NativeHttpConnection implements Connection {
    request: Request;
    response: Observable<Response>;
    readyState: ReadyState;
    constructor(req: Request, nativeHttp: HTTP, baseResponseOptions?: ResponseOptions);
    private detectRequestMethod(req);
    private fireResponse(responseObserver, responseOptions, baseResponseOptions?);
    private getBodyParams(query);
}
export declare class NativeHttpBackend implements ConnectionBackend {
    private nativeHttp;
    private baseResponseOptions;
    constructor(nativeHttp: HTTP, baseResponseOptions: ResponseOptions);
    createConnection(request: Request): Connection;
}
