var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { ConnectionBackend } from '@angular/http';
import { Injectable } from '@angular/core';
import { NativeHttpBackend } from './native-http-backend';
import { checkAvailability } from '@ionic-native/core';
var NativeHttpFallback = (function () {
    function NativeHttpFallback(nativeHttpBackend, fallback) {
        this.nativeHttpBackend = nativeHttpBackend;
        this.fallback = fallback;
        this.nativeIsForced = null;
        this.nativeIsAvailable = null;
    }
    NativeHttpFallback.prototype.createConnection = function (request) {
        /**
         * Native HTTP Cordova plugin doesn't like local requests
         */
        var isOutgoingRequest = /^(http|https):\/\//.test(request.url);
        if (isOutgoingRequest && this.isNativeHttpAvailable()) {
            return this.nativeHttpBackend.createConnection(request);
        }
        else {
            return this.fallback.createConnection(request);
        }
    };
    /**
     * Enable/disable forced native HTTP usage without preliminary check. Helpful for unit testing
     *
     * @param {boolean} isEnabled
     */
    NativeHttpFallback.prototype.forceNative = function (isEnabled) {
        this.nativeIsForced = isEnabled;
    };
    NativeHttpFallback.prototype.isNativeHttpAvailable = function () {
        if (this.nativeIsForced !== null) {
            return this.nativeIsForced;
        }
        if (this.nativeIsAvailable === null) {
            this.nativeIsAvailable = checkAvailability('cordovaHTTP') === true;
        }
        return this.nativeIsAvailable;
    };
    NativeHttpFallback = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [NativeHttpBackend,
            ConnectionBackend])
    ], NativeHttpFallback);
    return NativeHttpFallback;
}());
export { NativeHttpFallback };
//# sourceMappingURL=native-http-fallback.js.map